---
title: "Getting Started Overview"
linkTitle: "Overview"
weight: 2
---

With Kf, you can migrate your Cloud Foundry apps to
Kubernetes without changing your developer workflows.

Use the following sections to get started deploying Cloud Foundry apps
to Kf.

## Get started with a quickstart

Use the [quickstart]({{<relref "quickstart">}}) to install Kf and deploy a
simple test Cloud Foundry app. This introduces you to the basic steps you'd
perform for most app deployments.

## Get an introduction to key concepts

For an introduction to the value of Kf, as well as
high-level overviews of the technology, see the following documents:

-  To learn more about how Kf works, see
   [Kf dependencies and architecture]({{< relref "kf-dependencies" >}}).
-  For a side-by-side comparison of Cloud Foundry and Kf
   components, see
   [Compare Cloud Foundry and Kf services]({{< relref "compare-services" >}}).
-  To learn how to use service brokers with Kf,
   see [Service brokers]({{< relref "about-service-brokers" >}}).
-  For more information about Kf security design, see the
   [Security overview]({{< relref "security-overview" >}}).