// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	v1alpha1 "kf-operator/pkg/apis/kfsystem/v1alpha1"
	scheme "kf-operator/pkg/client/clientset/versioned/scheme"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// KfSystemsGetter has a method to return a KfSystemInterface.
// A group's client should implement this interface.
type KfSystemsGetter interface {
	KfSystems() KfSystemInterface
}

// KfSystemInterface has methods to work with KfSystem resources.
type KfSystemInterface interface {
	Create(ctx context.Context, kfSystem *v1alpha1.KfSystem, opts v1.CreateOptions) (*v1alpha1.KfSystem, error)
	Update(ctx context.Context, kfSystem *v1alpha1.KfSystem, opts v1.UpdateOptions) (*v1alpha1.KfSystem, error)
	UpdateStatus(ctx context.Context, kfSystem *v1alpha1.KfSystem, opts v1.UpdateOptions) (*v1alpha1.KfSystem, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.KfSystem, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.KfSystemList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.KfSystem, err error)
	KfSystemExpansion
}

// kfSystems implements KfSystemInterface
type kfSystems struct {
	client rest.Interface
}

// newKfSystems returns a KfSystems
func newKfSystems(c *KfV1alpha1Client) *kfSystems {
	return &kfSystems{
		client: c.RESTClient(),
	}
}

// Get takes name of the kfSystem, and returns the corresponding kfSystem object, and an error if there is any.
func (c *kfSystems) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.KfSystem, err error) {
	result = &v1alpha1.KfSystem{}
	err = c.client.Get().
		Resource("kfsystems").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of KfSystems that match those selectors.
func (c *kfSystems) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.KfSystemList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.KfSystemList{}
	err = c.client.Get().
		Resource("kfsystems").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested kfSystems.
func (c *kfSystems) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("kfsystems").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a kfSystem and creates it.  Returns the server's representation of the kfSystem, and an error, if there is any.
func (c *kfSystems) Create(ctx context.Context, kfSystem *v1alpha1.KfSystem, opts v1.CreateOptions) (result *v1alpha1.KfSystem, err error) {
	result = &v1alpha1.KfSystem{}
	err = c.client.Post().
		Resource("kfsystems").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kfSystem).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a kfSystem and updates it. Returns the server's representation of the kfSystem, and an error, if there is any.
func (c *kfSystems) Update(ctx context.Context, kfSystem *v1alpha1.KfSystem, opts v1.UpdateOptions) (result *v1alpha1.KfSystem, err error) {
	result = &v1alpha1.KfSystem{}
	err = c.client.Put().
		Resource("kfsystems").
		Name(kfSystem.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kfSystem).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *kfSystems) UpdateStatus(ctx context.Context, kfSystem *v1alpha1.KfSystem, opts v1.UpdateOptions) (result *v1alpha1.KfSystem, err error) {
	result = &v1alpha1.KfSystem{}
	err = c.client.Put().
		Resource("kfsystems").
		Name(kfSystem.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kfSystem).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the kfSystem and deletes it. Returns an error if one occurs.
func (c *kfSystems) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("kfsystems").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *kfSystems) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("kfsystems").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched kfSystem.
func (c *kfSystems) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.KfSystem, err error) {
	result = &v1alpha1.KfSystem{}
	err = c.client.Patch(pt).
		Resource("kfsystems").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
