// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	v1alpha1 "kf-operator/pkg/apis/operand/v1alpha1"
	scheme "kf-operator/pkg/client/clientset/versioned/scheme"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ActiveOperandsGetter has a method to return a ActiveOperandInterface.
// A group's client should implement this interface.
type ActiveOperandsGetter interface {
	ActiveOperands(namespace string) ActiveOperandInterface
}

// ActiveOperandInterface has methods to work with ActiveOperand resources.
type ActiveOperandInterface interface {
	Create(ctx context.Context, activeOperand *v1alpha1.ActiveOperand, opts v1.CreateOptions) (*v1alpha1.ActiveOperand, error)
	Update(ctx context.Context, activeOperand *v1alpha1.ActiveOperand, opts v1.UpdateOptions) (*v1alpha1.ActiveOperand, error)
	UpdateStatus(ctx context.Context, activeOperand *v1alpha1.ActiveOperand, opts v1.UpdateOptions) (*v1alpha1.ActiveOperand, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.ActiveOperand, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.ActiveOperandList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ActiveOperand, err error)
	ActiveOperandExpansion
}

// activeOperands implements ActiveOperandInterface
type activeOperands struct {
	client rest.Interface
	ns     string
}

// newActiveOperands returns a ActiveOperands
func newActiveOperands(c *OperandV1alpha1Client, namespace string) *activeOperands {
	return &activeOperands{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the activeOperand, and returns the corresponding activeOperand object, and an error if there is any.
func (c *activeOperands) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ActiveOperand, err error) {
	result = &v1alpha1.ActiveOperand{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("activeoperands").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ActiveOperands that match those selectors.
func (c *activeOperands) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ActiveOperandList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.ActiveOperandList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("activeoperands").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested activeOperands.
func (c *activeOperands) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("activeoperands").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a activeOperand and creates it.  Returns the server's representation of the activeOperand, and an error, if there is any.
func (c *activeOperands) Create(ctx context.Context, activeOperand *v1alpha1.ActiveOperand, opts v1.CreateOptions) (result *v1alpha1.ActiveOperand, err error) {
	result = &v1alpha1.ActiveOperand{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("activeoperands").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(activeOperand).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a activeOperand and updates it. Returns the server's representation of the activeOperand, and an error, if there is any.
func (c *activeOperands) Update(ctx context.Context, activeOperand *v1alpha1.ActiveOperand, opts v1.UpdateOptions) (result *v1alpha1.ActiveOperand, err error) {
	result = &v1alpha1.ActiveOperand{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("activeoperands").
		Name(activeOperand.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(activeOperand).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *activeOperands) UpdateStatus(ctx context.Context, activeOperand *v1alpha1.ActiveOperand, opts v1.UpdateOptions) (result *v1alpha1.ActiveOperand, err error) {
	result = &v1alpha1.ActiveOperand{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("activeoperands").
		Name(activeOperand.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(activeOperand).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the activeOperand and deletes it. Returns an error if one occurs.
func (c *activeOperands) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("activeoperands").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *activeOperands) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("activeoperands").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched activeOperand.
func (c *activeOperands) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ActiveOperand, err error) {
	result = &v1alpha1.ActiveOperand{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("activeoperands").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
