// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"
	v1alpha1 "kf-operator/pkg/apis/operand/v1alpha1"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeOperands implements OperandInterface
type FakeOperands struct {
	Fake *FakeOperandV1alpha1
}

var operandsResource = schema.GroupVersionResource{Group: "operand.run.cloud.google.com", Version: "v1alpha1", Resource: "operands"}

var operandsKind = schema.GroupVersionKind{Group: "operand.run.cloud.google.com", Version: "v1alpha1", Kind: "Operand"}

// Get takes name of the operand, and returns the corresponding operand object, and an error if there is any.
func (c *FakeOperands) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.Operand, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(operandsResource, name), &v1alpha1.Operand{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Operand), err
}

// List takes label and field selectors, and returns the list of Operands that match those selectors.
func (c *FakeOperands) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.OperandList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(operandsResource, operandsKind, opts), &v1alpha1.OperandList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.OperandList{ListMeta: obj.(*v1alpha1.OperandList).ListMeta}
	for _, item := range obj.(*v1alpha1.OperandList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested operands.
func (c *FakeOperands) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(operandsResource, opts))
}

// Create takes the representation of a operand and creates it.  Returns the server's representation of the operand, and an error, if there is any.
func (c *FakeOperands) Create(ctx context.Context, operand *v1alpha1.Operand, opts v1.CreateOptions) (result *v1alpha1.Operand, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(operandsResource, operand), &v1alpha1.Operand{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Operand), err
}

// Update takes the representation of a operand and updates it. Returns the server's representation of the operand, and an error, if there is any.
func (c *FakeOperands) Update(ctx context.Context, operand *v1alpha1.Operand, opts v1.UpdateOptions) (result *v1alpha1.Operand, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(operandsResource, operand), &v1alpha1.Operand{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Operand), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeOperands) UpdateStatus(ctx context.Context, operand *v1alpha1.Operand, opts v1.UpdateOptions) (*v1alpha1.Operand, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(operandsResource, "status", operand), &v1alpha1.Operand{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Operand), err
}

// Delete takes name of the operand and deletes it. Returns an error if one occurs.
func (c *FakeOperands) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(operandsResource, name), &v1alpha1.Operand{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeOperands) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(operandsResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.OperandList{})
	return err
}

// Patch applies the patch and returns the patched operand.
func (c *FakeOperands) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.Operand, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(operandsResource, name, pt, data, subresources...), &v1alpha1.Operand{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Operand), err
}
