// Code generated by informer-gen. DO NOT EDIT.

package externalversions

import (
	"fmt"
	v1alpha1 "kf-operator/pkg/apis/kfsystem/v1alpha1"
	operandv1alpha1 "kf-operator/pkg/apis/operand/v1alpha1"

	schema "k8s.io/apimachinery/pkg/runtime/schema"
	cache "k8s.io/client-go/tools/cache"
)

// GenericInformer is type of SharedIndexInformer which will locate and delegate to other
// sharedInformers based on type
type GenericInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() cache.GenericLister
}

type genericInformer struct {
	informer cache.SharedIndexInformer
	resource schema.GroupResource
}

// Informer returns the SharedIndexInformer.
func (f *genericInformer) Informer() cache.SharedIndexInformer {
	return f.informer
}

// Lister returns the GenericLister.
func (f *genericInformer) Lister() cache.GenericLister {
	return cache.NewGenericLister(f.Informer().GetIndexer(), f.resource)
}

// ForResource gives generic access to a shared informer of the matching type
// TODO extend this to unknown resources with a client pool
func (f *sharedInformerFactory) ForResource(resource schema.GroupVersionResource) (GenericInformer, error) {
	switch resource {
	// Group=kf.dev, Version=v1alpha1
	case v1alpha1.SchemeGroupVersion.WithResource("kfsystems"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Kf().V1alpha1().KfSystems().Informer()}, nil

		// Group=operand.run.cloud.google.com, Version=v1alpha1
	case operandv1alpha1.SchemeGroupVersion.WithResource("activeoperands"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Operand().V1alpha1().ActiveOperands().Informer()}, nil
	case operandv1alpha1.SchemeGroupVersion.WithResource("clusteractiveoperands"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Operand().V1alpha1().ClusterActiveOperands().Informer()}, nil
	case operandv1alpha1.SchemeGroupVersion.WithResource("operands"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Operand().V1alpha1().Operands().Informer()}, nil

	}

	return nil, fmt.Errorf("no informer found for %v", resource)
}
